'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.computed = computed;

var _trimkit = require('trimkit');

function computed(dependencies, fn) {
    var val = undefined;
    var version = 0;
    if ((0, _trimkit.isFunction)(dependencies)) {
        fn = dependencies;
        dependencies = [];
    }
    var previousVersions = [];

    var accessor = function _computed() {
        var currentVersions = dependencies.map(function (d) {
            return d.v();
        });

        if (currentVersions.some(function (v, i) {
            return v !== previousVersions[i];
        }) || !dependencies.length) {
            previousVersions = currentVersions;
            version++;
            val = fn.apply(null, dependencies.map(function (d) {
                return d();
            }));
        }
        return val;
    };
    accessor.v = function () {
        accessor();
        return version;
    };

    return accessor;
}