'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.debounce = debounce;

var _trimkit = require('trimkit');

function debounce(method) {
    var afterTime = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 16;

    var id = void 0;
    var args = void 0;
    function clear() {
        if (id !== _trimkit.Null) {
            clearTimeout(id);
            id = _trimkit.Null;
        }
    }

    function debounceInterval() {
        clear();
        try {
            method.apply(_trimkit.Null, args);
        } catch (e) {
            args = [];
            throw e;
        }
    }

    var wrapped = function debounceWrapper() {
        id = setTimeout(debounceInterval, afterTime);
        args = (0, _trimkit.asArray)(arguments);
    };

    wrapped.clear = clear;

    return wrapped;
}