'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.throttle = throttle;

var _trimkit = require('trimkit');

function throttle(method) {
    var afterTime = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 16;

    var id = _trimkit.Null;
    function throttleInterval() {
        id = _trimkit.Null;
    }

    return function throttleWrapper() {
        if (id === _trimkit.Null) {
            id = setTimeout(throttleInterval, afterTime);
            method.apply(_trimkit.Null, arguments);
        }
    };
}