import { asArray, Null } from 'trimkit';


export function debounce(method, afterTime = 16) {
    let id;
    let args;
    function clear() {
        if (id !== Null) {
            clearTimeout(id);
            id = Null;
        }
    }

    function debounceInterval() {
        clear();
        try {
            method.apply(Null, args);
        } catch (e) {
            args = [];
            throw e;
        }
    }

    const wrapped = function debounceWrapper() {
        id = setTimeout(debounceInterval, afterTime);
        args = asArray(arguments);
    };

    wrapped.clear = clear;

    return wrapped;
}
