import { Null } from 'trimkit';


export function throttle(method, afterTime = 16) {
    let id = Null;
    function throttleInterval() {
        id = Null;
    }

    return function throttleWrapper() {
        if (id === Null) {
            id = setTimeout(throttleInterval, afterTime);
            method.apply(Null, arguments);
        }
    };
}
