// @flow

const toggleWeakMap = new WeakMap();

export function toggle<T>(prop: ObservableType<T>): ObservableType<T> {
    if (!toggleWeakMap.has(prop)) {
        toggleWeakMap.set(prop, function _toggle() {
            prop(!prop());
        });
    }

    return toggleWeakMap.get(prop);
}
